Index: Commands2.cpp
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/Commands2.cpp,v
retrieving revision 1.119
diff -u -p -b -r1.119 Commands2.cpp
--- Commands2.cpp	23 Jan 2005 01:34:53 -0000	1.119
+++ Commands2.cpp	10 Apr 2005 22:43:18 -0000
@@ -739,22 +729,21 @@ bool Commands::dele(User *user, string f
   else
     message = "250 'DELE' command successful.";
 
-  ftp_send(user, message);
+  *user << message << "\r\n";
   return(true);
 }
 
-bool Commands::port(User *user, string argument, unsigned int flag)
+BABY_COM(Commands::port)
 {
   string tmp_adress, message;
-  int port;
-
-  memset(&user->data_addr, 0, sizeof(user->data_addr));
+  int port = -1;
 
-  if(user->settings.test(EPSV_ONLY))
+  if(user->settings(EPSV_ONLY))
     message = "501 Only 'EPSV' may be used after the issuing of 'EPSV ALL'";
 
-  else if((config->get_user(user->user_name).only_passive))
-    message = "501 Sorry, active data transfers are disabled for your account.";
+  else if((config->get_user(user->user_name()).only_passive))
+    message =
+      "501 Sorry, active data transfers are disabled for your account.";
 
   else if(util.is_set(flag, COM_PORT))
   {
@@ -770,17 +759,18 @@ bool Commands::port(User *user, string a
       tmp_adress += token->nextToken() + "."; // the wrong direction, it's
       tmp_adress += token->nextToken();       // weird.
 
-      port = ntohs(atoi((token->nextToken()).c_str()) << 8 | atoi((token->nextToken()).c_str()));
+      port = atoi((token->nextToken()).c_str()) * 256 +
+          atoi((token->nextToken()).c_str());
     }
     delete token;
   }
   else if(util.is_set(flag, COM_EPRT))
   {
-    char separator[1];
-    separator[0] = static_cast<char>(argument[0]);
-    class StringTokenizer *token = new StringTokenizer(argument, separator, false);
+    class StringTokenizer *token =
+      new StringTokenizer(argument, argument.substr(0, 1), false);
 
-    if(token->countTokens() != 3 || argument[argument.size() - 1] != argument[0])
+    if(token->countTokens() != 3 ||
+        argument[argument.size() - 1] != argument[0])
       message = "501 Illegal 'EPRT' command.";
 
     else
@@ -788,7 +778,7 @@ bool Commands::port(User *user, string a
       if(token->nextToken() == util.itos(PROT_IPV4))
       {
         tmp_adress = token->nextToken();
-        port = htons(atoi(token->nextToken().c_str()));
+        port = atoi(token->nextToken().c_str());
       }
       else
         message = "522 Network protocol not supported, use (1)";
@@ -796,10 +786,10 @@ bool Commands::port(User *user, string a
     delete token;
   }
 
-  if(message.size() == 0)
+  if(message.empty())
   {
-    sem_wait(&user->user_lock);
-    if((inet_aton(tmp_adress.c_str(), &user->data_addr.sin_addr)) == 0)
+    struct sockaddr_in temp_addr;
+    if((inet_aton(tmp_adress.c_str(), &temp_addr.sin_addr)) == 0)
     {
       message = "501 Illegal '";
       message += (util.is_set(flag, COM_PORT) ? "PORT" : "EPRT");
@@ -807,32 +797,31 @@ bool Commands::port(User *user, string a
     }
     else
     {
-      user->data_addr.sin_port = port;
-      user->data_addr.sin_family = AF_INET;
-      user->settings.reset(PASSIVE);
+      temp_addr.sin_port = htons(port);
+      temp_addr.sin_family = AF_INET;
+      user->settings(PASSIVE, B_RESET);
       message += "200 '";
       message += (util.is_set(flag, COM_PORT) ? "PORT" : "EPRT");
       message += "' command successful.";
     }
-    sem_post(&user->user_lock);
+    user->data_addr(temp_addr);
   }
 
-  ftp_send(user, message);
+  *user << message << "\r\n";
   return(true);
 }
 
-bool Commands::pasv(User *user, string argument, unsigned int flag)
+BABY_COM(Commands::pasv)
 {
   string message;
 
   if(util.is_set(flag, COM_EPSV) && argument.size() > 0)
   {
-    transform(argument.begin(), argument.end(), argument.begin(), (int(*)(int))toupper);
+    transform(argument.begin(), argument.end(), argument.begin(),
+        (int(*)(int))toupper);
     if(argument == "ALL" && util.is_set(flag, COM_EPSV))
     {
-      sem_wait(&user->user_lock);
-      user->settings.set(EPSV_ONLY);
-      sem_post(&user->user_lock);
+      user->settings(EPSV_ONLY, B_SET);
       message = "200 Now only accepting 'EPSV'";
     }
     else
@@ -840,45 +829,45 @@ bool Commands::pasv(User *user, string a
   }
   else
   {
-    struct sockaddr_in tmp_addr, tmp_addr2;
+    struct sockaddr_in tmp_addr = {0}, tmp_addr1 = {0}, tmp_addr2 = {0};
     socklen_t len = sizeof(tmp_addr);
 
-    memset(&tmp_addr, 0, len);
-    memset(&tmp_addr2, 0, len);
+    if(user->data_id())
+      close(user->data_id());
 
-    sem_wait(&user->user_lock);
-    memset(&user->data_addr, 0, sizeof(user->data_addr));
-    if(user->data_id)
-      close(user->data_id);
-
-    user->data_id = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
-    user->data_addr.sin_family = AF_INET;
-    user->data_addr.sin_addr.s_addr = INADDR_ANY;
-    bind(user->data_id, reinterpret_cast<struct sockaddr*>(&user->data_addr), sizeof(user->data_addr));
-    listen(user->data_id, 1);
-    getsockname(user->data_id, reinterpret_cast<struct sockaddr*>(&tmp_addr), &len);
-    getsockname(user->socket_id, reinterpret_cast<struct sockaddr*>(&tmp_addr2), &len);
-    user->settings.set(PASSIVE);
-    sem_post(&user->user_lock);
+    user->data_id(socket(AF_INET, SOCK_STREAM, IPPROTO_TCP));
+    tmp_addr.sin_family = AF_INET;
+    tmp_addr.sin_addr.s_addr = INADDR_ANY;
+    bind(user->data_id(), reinterpret_cast<struct sockaddr*>
+        (&tmp_addr), sizeof(tmp_addr));
+    user->data_addr(tmp_addr);
+    listen(user->data_id(), 1);
+    getsockname(user->data_id(), reinterpret_cast<struct sockaddr*>
+        (&tmp_addr1), &len);
+    getsockname(user->socket_id(), reinterpret_cast<struct sockaddr*>
+        (&tmp_addr2), &len);
+    user->settings(PASSIVE, B_SET);
 
-    unsigned int p = ntohs(tmp_addr.sin_port);
+    unsigned int p = ntohs(tmp_addr1.sin_port);
 
     if(util.is_set(flag, COM_PASV))
     {
-      if(user->settings.test(EPSV_ONLY))
-        message = "501 Only 'EPSV' may be used after the issuing of 'EPSV ALL'";
+      if(user->settings(EPSV_ONLY))
+        message =
+          "501 Only 'EPSV' may be used after the issuing of 'EPSV ALL'";
 
       else
       {
-        class StringTokenizer *token = new StringTokenizer(inet_ntoa(tmp_addr2.sin_addr), ".", false);
+        class StringTokenizer *token =
+          new StringTokenizer(inet_ntoa(tmp_addr2.sin_addr), ".", false);
 
         message = "227 Entering Passive Mode (";
         message += token->nextToken() + ",";
         message += token->nextToken() + ",";
         message += token->nextToken() + ",";
         message += token->nextToken() + ",";
-        message += util.itos((p >> 8) & 255) + ","
-          + util.itos(p & 255) + ").";
+        message += util.itos(p / 256) + ","
+          + util.itos(p % 256) + ").";
 
         delete token;
       }
@@ -890,15 +879,16 @@ bool Commands::pasv(User *user, string a
           message = "522 Network protocol not supported, use (1)";
 
       if(message.size() == 0)
-        message = "229 Entering Extended Passive Mode (|||" + util.itos(p) + "|)";
+        message = "229 Entering Extended Passive Mode (|||" +
+          util.itos(p) + "|)";
     }
   }
-  ftp_send(user, message);
+  *user << message << "\r\n";
   return(true);
 }
 
 // rnfr and rnto
-bool Commands::rname(User *user, string argument, unsigned int flag)
+BABY_COM(Commands::rname)
 {
   string file_name, message;
 
@@ -906,31 +896,29 @@ bool Commands::rname(User *user, string 
 
   if(util.is_set(flag, COM_FROM))
   {
-    sem_wait(&user->user_lock);
-    user->temp_buf = file_name;
-    sem_post(&user->user_lock);
+    user->temp_buf(file_name);
     message = "350 Command OK, waiting for RNTO.";
   }
   else if(util.is_set(flag, COM_TO))
   {
-    if(user->temp_buf.size() == 0)
+    if(user->temp_buf().size() == 0)
       message = "503 RNTO must come after RNFR.";
     else
     {
-      if(!(rename(user->temp_buf.c_str(), file_name.c_str())))
-        message = "250 " + user->temp_buf + " renamed to " + file_name + ".";
+      if(!(rename(user->temp_buf().c_str(), file_name.c_str())))
+        message = "250 " + user->temp_buf() + " renamed to " + file_name + ".";
       else if(errno == EACCES)
         message = "550 Access denied.";
       else
         message = "553 Rename failed.";
-      user->temp_buf.erase();
+      user->temp_buf("");
     }
   }
-  ftp_send(user, message);
+  *user << message << "\r\n";
   return(true);
 }
 
-bool Commands::opts(User *user, string argument, unsigned int flag)
+BABY_COM(Commands::opts)
 {
   string command, message;
   class StringTokenizer *st;
@@ -943,8 +931,9 @@ bool Commands::opts(User *user, string a
   }
   else
   {
-    transform(argument.begin(), argument.end(), argument.begin(), (int(*)(int))toupper);
-    st = new StringTokenizer(argument, " ", true);
+    transform(argument.begin(), argument.end(), argument.begin(),
+        (int(*)(int))toupper);
+    st = new StringTokenizer(argument, " ", false);
     command = st->nextToken();
     argument = st->restTokens();
     delete st;
@@ -954,23 +943,20 @@ bool Commands::opts(User *user, string a
       string fact;
       st = new StringTokenizer(argument, ";", false);
 
-      sem_wait(&user->user_lock);
       while(st->hasMoreTokens())
       {
         fact = st->nextToken();
-        if(fact == "TYPE") user->settings.flip(FACT_TYPE);
-        else if(fact == "SIZE") user->settings.flip(FACT_SIZE);
-        else if(fact == "MODIFY") user->settings.flip(FACT_MODIFY);
-        else if(fact == "UNIQUE") user->settings.flip(FACT_UNIQUE);
-        else if(fact == "PERM") user->settings.flip(FACT_PERM);
-        else if(fact == "UNIX.MODE") user->settings.flip(FACT_U_MODE);
-        else if(fact == "UNIX.UID") user->settings.flip(FACT_U_UID);
-        else if(fact == "UNIX.GID") user->settings.flip(FACT_U_GID);
-        else if(fact == "UNIX.LINK") user->settings.flip(FACT_U_LINK);
+        if(fact == "TYPE") user->settings(FACT_TYPE, B_FLIP);
+        else if(fact == "SIZE") user->settings(FACT_SIZE, B_FLIP);
+        else if(fact == "MODIFY") user->settings(FACT_MODIFY, B_FLIP);
+        else if(fact == "UNIQUE") user->settings(FACT_UNIQUE, B_FLIP);
+        else if(fact == "PERM") user->settings(FACT_PERM, B_FLIP);
+        else if(fact == "UNIX.MODE") user->settings(FACT_U_MODE, B_FLIP);
+        else if(fact == "UNIX.UID") user->settings(FACT_U_UID, B_FLIP);
+        else if(fact == "UNIX.GID") user->settings(FACT_U_GID, B_FLIP);
+        else if(fact == "UNIX.LINK") user->settings(FACT_U_LINK, B_FLIP);
       };
 
-      sem_post(&user->user_lock);
-
       message = "200 MLST string now showing: " + mlst_string(user);
       delete st;
     }
@@ -978,7 +964,7 @@ bool Commands::opts(User *user, string a
       message = "501 " + command + " not known as argument to OPTS.";
   }
 
-  ftp_send(user, message);
+  *user << message << "\r\n";
 
   return(true);
 }
@@ -987,33 +973,43 @@ string Commands::mlst_string(User *user)
 {
   string message;
 
-  message += ("Type"); message += (user->settings.test(FACT_TYPE) ? "*;" : ";");
-  message += ("Size"); message += (user->settings.test(FACT_SIZE) ? "*;" : ";");
-  message += ("Modify"); message += (user->settings.test(FACT_MODIFY) ? "*;" : ";");
-  message += ("Unique"); message += (user->settings.test(FACT_UNIQUE) ? "*;" : ";");
-  message += ("Perm"); message += (user->settings.test(FACT_PERM) ? "*;" : ";");
-  message += ("Unix.mode"); message += (user->settings.test(FACT_U_MODE) ? "*;" : ";");
-  message += ("Unix.uid"); message += (user->settings.test(FACT_U_UID) ? "*;" : ";");
-  message += ("Unix.gid"); message += (user->settings.test(FACT_U_GID) ? "*;" : ";");
-  message += ("Unix.link"); message += (user->settings.test(FACT_U_LINK) ? "*;" : ";");
+  message += ("Type"); message +=
+    (user->settings(FACT_TYPE) ? "*;" : ";");
+  message += ("Size"); message +=
+    (user->settings(FACT_SIZE) ? "*;" : ";");
+  message += ("Modify"); message +=
+    (user->settings(FACT_MODIFY) ? "*;" : ";");
+  message += ("Unique"); message +=
+    (user->settings(FACT_UNIQUE) ? "*;" : ";");
+  message += ("Perm"); message +=
+    (user->settings(FACT_PERM) ? "*;" : ";");
+  message += ("Unix.mode"); message +=
+    (user->settings(FACT_U_MODE) ? "*;" : ";");
+  message += ("Unix.uid"); message +=
+    (user->settings(FACT_U_UID) ? "*;" : ";");
+  message += ("Unix.gid"); message +=
+    (user->settings(FACT_U_GID) ? "*;" : ";");
+  message += ("Unix.link"); message +=
+    (user->settings(FACT_U_LINK) ? "*;" : ";");
   return(message);
 }
 
 // functions for small left over commands (noop, pwd, etc...)
-bool Commands::sim1(User *user, string argument, unsigned int flag)
+BABY_COM(Commands::sim1)
 {
   string message;
 
-  transform(argument.begin(), argument.end(), argument.begin(), (int(*)(int))toupper);
+  transform(argument.begin(), argument.end(), argument.begin(),
+      (int(*)(int))toupper);
 
   if(util.is_set(flag, COM_NOOP))
     message = "200 'NOOP': Command successful.";
 
   else if(util.is_set(flag, COM_PWD))
   {
-    string dir = user->current_dir;
-    if(user->root_dir.size() > 1)
-      dir.erase(0, user->root_dir.size());
+    string dir = user->current_dir();
+    if(user->root_dir().size() > 1)
+      dir.erase(0, user->root_dir().size());
     if(dir == "")
       dir = "/";
     message = "257 \"" + dir + "\" is current directory.";
@@ -1045,16 +1041,12 @@ bool Commands::sim1(User *user, string a
     if(argument == "A" || argument == "A N")
     {
       message = "200 Type set to " + argument + ".";
-      sem_wait(&user->user_lock);
-      user->settings.reset(BINARY);
-      sem_post(&user->user_lock);
+      user->settings(BINARY, B_RESET);
     }
     else if(argument == "I" || argument == "L 8")
     {
       message = "200 Type set to " + argument + ".";
-      sem_wait(&user->user_lock);
-      user->settings.reset(BINARY);
-      sem_post(&user->user_lock);
+      user->settings(BINARY, B_SET);
     }
     else
       message = "504 'TYPE " + argument + "' not understood.";
@@ -1080,34 +1072,36 @@ bool Commands::sim1(User *user, string a
 #ifdef USE_TLS
   else if(util.is_set(flag, COM_PBSZ))
   {
-    if(user->settings.test(TLS_ENABLED))
+    if(user->settings(TLS_ENABLED))
     {
       if(argument == "0")
       {
         message = "200 PBSZ set for stream transfer.";
-        user->settings.set(TLS_PBSZ);
+        user->settings(TLS_PBSZ, B_SET);
       }
       else
         message = "501 PBSZ has to be set to 0 for use with TLS.";
     }
     else
-      message = "503 AUTH must be issued and negotiated before PBSZ can be used.";
+      message =
+        "503 AUTH must be issued and negotiated before PBSZ can be used.";
   }
 
   else if(util.is_set(flag, COM_PROT))
   {
-    if(!user->settings.test(TLS_ENABLED) || !user->settings.test(TLS_PBSZ))
-      message = "503 AUTH and PBSZ has to be issued and negotiated before PROT.";
+    if(!user->settings(TLS_ENABLED) || !user->settings(TLS_PBSZ))
+      message =
+        "503 AUTH and PBSZ has to be issued and negotiated before PROT.";
     else
       switch(argument[0])
       {
         case 'C':
           message = "200 Data connection set to CLEAR level.";
-          user->settings.reset(TLS_PROT_D);
+          user->settings(TLS_PROT_D, B_RESET);
           break;
         case 'P':
           message = "200 Data connection set to PRIVATE level.";
-          user->settings.set(TLS_PROT_D);
+          user->settings(TLS_PROT_D, B_SET);
           break;
         case 'S':
         case 'E':
@@ -1119,13 +1113,13 @@ bool Commands::sim1(User *user, string a
   }
   else if(util.is_set(flag, COM_CCC)) // Clear Command Channel
   {
-    if(!user->settings.test(TLS_ENABLED))
-      message = "533 CCC can only be issued on a protected control connection.";
+    if(!user->settings(TLS_ENABLED))
+      message =
+        "533 CCC can only be issued on a protected control connection.";
     else // code for disallowing CCC should be above, containing a 534
     {
-      ftp_send(user, "200 Disabling TLS, control connection is now CLEAR.");
-      gnutls_bye(user->ctrl_session, GNUTLS_SHUT_RDWR);
-      user->settings.reset(TLS_ENABLED);
+      *user << "200 Disabling TLS, control connection is now CLEAR.\r\n";
+      user->disengage_tls();
     }
   }
   else if(util.is_set(flag, COM_CONF | COM_MIC | COM_ENC))
@@ -1141,7 +1135,7 @@ bool Commands::sim1(User *user, string a
     else
       command += "ENC";
 
-    if(!user->settings.test(TLS_ENABLED))
+    if(!user->settings(TLS_ENABLED))
       message = "503 Command " + command
         + " can not be issued before a valid security exchange.";
     else
@@ -1150,11 +1144,11 @@ bool Commands::sim1(User *user, string a
 #endif // USE_TLS
 
   if(message.size() > 0)
-    ftp_send(user, message);
+    *user << message << "\r\n";
   return(true);
 }
 
-bool Commands::sim2(User *user, string argument, unsigned int flag)
+BABY_COM(Commands::sim2)
 {
   string file_name, message;
   struct stat stt;
@@ -1166,7 +1160,7 @@ bool Commands::sim2(User *user, string a
       message = "213 " + util.itos(stt.st_size);
 
     else if(util.is_set(flag, COM_MDTM))
-      message = "213 " + mod_time(stt);
+      util.time_string(message, "213 %Y%m%d%H%M%S", 19, stt.st_mtime);
 
     else if(util.is_set(flag, COM_MLST))
     {
@@ -1178,61 +1172,41 @@ bool Commands::sim2(User *user, string a
   else
     message = "550 \"" + argument + "\": No such file or directory.";
 
-  ftp_send(user, message);
+  *user << message << "\r\n";
   return(true);
 }
 
-string Commands::mod_time(struct stat stt)
-{
-  char date[16] = {0};
-  struct tm m;
-
-  gmtime_r(&(stt.st_mtime), &m);
-  strftime(date, 15, "%Y%m%d%H%M%S", &m);
-  string message = date;
-  return(message);
-}
-
 #ifdef USE_TLS
 
-bool Commands::auth(User *user, string argument, unsigned int flag)
+BABY_COM(Commands::auth)
 {
-  transform(argument.begin(), argument.end(), argument.begin(), (int(*)(int))toupper);
+  transform(argument.begin(), argument.end(), argument.begin(),
+      (int(*)(int))toupper);
 
   if(argument == "TLS" || argument == "TLS-C" || argument == "SSL")
   {
-    if(config->get_user(user->user_name).encryption == DENY)
+    if(config->get_user(user->user_name()).encryption == DENY)
     {
-      ftp_send(user, "421 Sorry, you are not allowed to use encryption, disconnecting.");
-      sem_wait(&user->user_lock);
-      user->logged_in = LOGGED_OUT;
-      sem_post(&user->user_lock);
-    }
-    sem_wait(&user->user_lock);
-    Commands::init_tls(user->ctrl_session);
-    user->settings.set(TLS_INITED);
-
-    gnutls_transport_set_ptr(user->ctrl_session, reinterpret_cast<gnutls_transport_ptr>(user->socket_id));
-    sem_post(&user->user_lock);
-    ftp_send(user, "234 Now starting encryption using TLS.");
-    sem_wait(&user->user_lock);
-
-    if(gnutls_handshake(user->ctrl_session) < 0)
+      *user <<
+        "421 Sorry, you are not allowed to use encryption, disconnecting.\r\n";
+      user->settings(FAILURE, B_SET);
+      return false;
+    }
+    *user << "234 Now starting encryption using TLS.\r\n";
+    if(!user->engage_tls())
     { // failure =(
-      user->logged_in = LOGGED_OUT;
-      sem_post(&user->user_lock);
-      ftp_send(user, "421 Handshake failed. Disconnecting.");
+      user->settings(FAILURE, B_SET);
+      *user << "421 Handshake failed. Disconnecting.\r\n";
     }
     else
     { // wee!
-      user->settings.set(TLS_ENABLED);
       if(argument == "SSL")
-        user->settings.set(TLS_PROT_D);
-      sem_post(&user->user_lock);
+        user->settings(TLS_PROT_D, B_SET);
     }
   }
   else
-    ftp_send(user, "504 Sorry, I don't understand the mechanism '" + argument + "'.");
+    *user << "504 Sorry, I don't understand the mechanism '"
+      << argument << "'.\r\n";
 
   return true;
 }
